# [Threat Stack](https://www.threatstack.com/) AppSec agent for Nodejs

# Installation
```
npm install bluefyre-agent-node
```

# Configuration

# Development

Development uses Docker, so [install docker first](https://docs.docker.com/docker-for-mac/install/).

## Image

To build the image for running or testing:
```
make build-image
```

## Tests

Tests use `mocha` framework and `unexpected` assertion library.

To run test, assuming you already built the docker image:
```
make test
```

To enable agent's debug logging during tests
```
make test DEBUG=1
```

## CI/CD

Gitlab CI packages the application as a .tgz archive. All jobs are defined in the `.gitlab-ci.yml` file in this project.

Commits to the master branch trigger packaging for the dev environment. The package will have the version `X.Y.Z-<$CI_PIPELINE_ID>`. Only pushing tag triggers a release package, which will omit the `-$CI_PIPELINE_ID` part of the version.

**NOTE: Currently, the deploy jobs do nothing. This should be changed when final repositories are determined**

### Versioning

It is recommended that the version in `package.json` should be updated via `npm version` *locally* on a developer's computer. This will update `package.json` and `package-lock.json`, create a commit, and tag the commit with `v${NEW_VERSION}`. If using one of the scripts defined below, the commit message is defined in the script (note `%s` in the message substitutes the new version into the message).

There are 3 built-in scripts to streamline this (execute them with `npm run <script-name>`):

- **patch-release**: For the semantic version X.Y.Z, it will update to X.Y.Z+1.
- **minor-release**: For the semantic version X.Y.Z, it will update to X.Y+1.Z.
- **major-release**: For the semantic version X.Y.Z, it will update to X+1.Y.Z.
