'use strict'

const debug = require('debug')('bluefyre:action:nosqli')
const RequestBlockedError = require('../errors').RequestBlockedError
const utils = require('../util/utils')
const qs = require('querystring')

function checkValue(key, value) {
  const unsafeRe = /\$/
  return (unsafeRe.test(key) || unsafeRe.test(qs.unescape(key)) || unsafeRe.test(qs.unescape(value))) && {key, value}
}

function nosql_injection(val) {
  const result = utils
    .walkKeys(val, checkValue)
    .filter(v => v)

  if (!result.length) return false

  return result
}

exports.action = function (data) {
  try {
    return data &&
      typeof data == 'object' &&
      nosql_injection(data)
  } catch (error) {
    debug('noSQLi action failed: %o', error)
    return false
  }
}

exports.blocking = true