'use strict'

const debug = require('debug')('bluefyre:action:sqli')
const is_sqli = require("bindings")("bluefyre").is_sqli
const utils = require('../util/utils')

function test(value) {
  const result = utils.checkValue(value, v => {
    const res = is_sqli(v)

    if (res) {
      return { signature: res, value: v }
    }

    return false
  })

  if (result) {
    if (Array.isArray(result)) {
      let found = result.filter(v => v)

      if (found.length) return found

      return false
    } else if (typeof result == 'object' && result.signature) {
      return [result]
    }
  }

  return false
}

exports.action = function (data) {
  try {
    return test(data)
  } catch (error) {
    debug('SQLi action failed: %o', error)
    return false
  }
}

exports.blocking = true