'use strict'

const debug = require('debug')('bluefyre:index')
var bluefyreAgentVer = require('../package.json').version;
debug(
  "Bluefyre Node.js plugin version: %s; Node engine version: %s.",
  bluefyreAgentVer,
  process.version
)


if (global.__BLUEFYRE) {
  debug('Attempting to load a second copy of Bluefyre from %s, using cache instead', __dirname)
  module.exports = global.__BLUEFYRE
} else {
  const exp = initialize()

  module.exports = exp
}


function initialize() {
  debug('Initializing Bluefyre Nodejs Plugin');

  try {
    debug('Directory of plugin %s', __dirname)

    var Agent = require('./bluefyreagent');
    var bf_agent = global.__BLUEFYRE = new Agent()

    const started_at = Date.now()

    bf_agent.start(function cb() {
      const now = Date.now()
      debug('Bluefyre Agent started in %d ms.', now - started_at)
    })

    return bf_agent
  } catch (error) {
    debug("Bluefyre Node.js Plugin loading failed .", error);
    return {}
  }
}
