// express-session-session.js
// author: sabin.thomas

'use strict'
var utils = require('../../../../util/utils')
const util = require('util')
const debug = require('debug')('bluefyre:3rdparty:express:express-session:session')
const Event = require('../../../../models/Event')
const BluefyreStackError = require('../../../../errors').BluefyreStackError

class ExpressSessionCookieEvent extends Event {
  constructor(method, payload = {}, trace) {
    super(payload, trace)
    this._data.module_name = 'express/session/cookie'
    this._data.method_name = method
    this._data.event_type = 'instrumentation'
  }
}

function wrapCookie(bluefyreAgent, expressSessSessModule){
  if (!expressSessSessModule){
    debug('No express-session-session module')
  }
  if (!bluefyreAgent){
    debug('No Bluefyre Agent')
  }

  var expressSessSessOrig = expressSessSessModule.prototype.construct

  expressSessSessModule.prototype.constructor = function wrappedExpressSessSess(req, data) {
    const payload = {config: data}

    const ev = new ExpressSessionCookieEvent('constructor', payload, new BluefyreStackError(wrappedExpressSessSess))

    bluefyreAgent.setEvent(ev)
    return expressSessSessOrig.apply(this, arguments)
  }
}


module.exports = function initialize(bluefyreAgent, expressSessSessModule) {
    debug('Loading express-session/session wrapper');
    if (!expressSessSessModule){
      debug('Did not load express-session/session successfully')
    }

    // wrapCookie(bluefyreAgent, expressSessSessModule)
}
