const actions = require('./actions')

let self_termination_timeout

function resetTimeout() {
  clearTimeout(self_termination_timeout)

  self_termination_timeout = setTimeout(_ => {
    process.exit(2)
  }, 6000)

  self_termination_timeout.unref()
}

process.on('message', function (payload) {
  resetTimeout()

  if (payload.heartbeat) {
    return
  }

  runAction(payload.action, payload.module_name, payload.payload, payload.req_id)
})

function runAction(action_name, module_name, payload, req_id) {
  const result = actions[action_name].action(payload)

  process.send({action: action_name, block: result, req_id})
}

resetTimeout()